import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/** El objetivo del juego es el avanzar por una autopista de una ciudad cualquiera,
 * pero como sucede en la mayora de las ciudades hay un problema caracterstico 
 * llamado bache, por lo cual el conductor debe de estar en todo momento al pendiente
 * de las condiciones del camino, para no caer en uno de estos peligrosos baches; ya 
 * que mientras ms se caiga el automvil en estas trampas se va a ir deteriorando el 
 * automvil, hasta el grado de quedarse en el camino o ser destruido.
 
 * En este camino el conductor tiene que mejorar sus habilidades de conduccin, ya que
 * en cada ciertos metros avanzados el lmite de velocidad de la autopista ir aumentando,
 * por lo que al llegar al primer kilometro, se tendr derecho  a usar una velocidad "turbo";
 * adems se tiene que ser cada vez ms certero para no caer en los baches o chocar contra
 * otros automviles.

 * El automvil cuenta con cierta resistencia a los daos causados por algn bache u otro
 * automvil y cierta cantidad de vidas.
 
 * BacheFormula es una idea, de una tpica carrera de formula... pero a sabiendas de que 
 * una calle comn se deteriora, se requiere de poseer de gran habilidad para no caer en 
 * los baches que pudiesen surgir por el camino... pero aun ah no termina la emocin se
 * requiere no chocar con el trafico por que lamentablemente este se encuentra avanzando
 * en sentido contrario a la circulacin, por lo que tambin los dems automovilistas ponen
 * en riesgo la integridad de nuestro automvil... as que cuidado jugador.....
 
 * Desarrollado para:
 * Universidad Autnoma de San Luis Potos
 * Facultad de Ingeniera
 * rea de Computacin e Informtica
 * Materia: Programacin Orientada a Objetos
 * Asesor: Dr. Hctor Gerardo Prez Gonzales
 * Periodo: AGO-DIC / 2010
 
 * @autores Edgar Efran Dorantes Padrn, Mximo Tovar Reyna
 * @version (no version)
 */

public class Carretera  extends World{
    private int limite=0, memEnergia = 8; 
    private boolean jugando = false;
    private Bache   []bache          = new Bache[2];
    private Jugador   jugador        = new Jugador();//!!!
    private Trafico []trafico        = new Trafico[3];
    private Etiqueta  vidasEtiqueta  = new Etiqueta("Vidas: 3");
    private Etiqueta  metrosEtiqueta = new Etiqueta("Metros: 0");
    private Etiqueta []menuEtiqueta  = new Etiqueta[3];   
    private Imagen    energia        = new Imagen("Vida8.png");
    private Imagen senal             = new Imagen("00km.png");
    private Boton jugar              = new Boton("car01-n.png");
    private Boton ayuda              = new Boton("Ayuda1.png");
    private Boton creditos           = new Boton("house-06.png");
    private Boton atras              = new Boton("Atras1.png");
    private GreenfootSound motor     = new GreenfootSound("Motor1.wav");
    
    public Carretera(){
        super(600, 400, 1); 
        creaObjetos();
        cargaMenu();
    }
    public void act(){
        
        if(jugando){//para evitar actualizar datos fuera de juego
            actualizaDatos();
            if(jugador.getMuerto()){
                restauraNivel();
                juegoPerdido();
            }
        }
        checaBotones();
    }
    
    /**
     * Crea los arreglos tanto de baches como de trafico asi como las tiquetas: jugar, ayuda y creditos.
     */
    public void creaObjetos(){
        for(int step = 0;step<2;step++)
            bache[step]   = new Bache();
        for(int step = 0;step<3;step++)
            trafico[step] = new Trafico();
        menuEtiqueta[0]   = new Etiqueta("JUGAR");
        menuEtiqueta[1]   = new Etiqueta("AYUDA");
        menuEtiqueta[2]   = new Etiqueta("CREDITOS");
    }
    /**
     * Encargado de agregar los objetos del menu al escenario, a fin de cargar la vista del menu
     */
    public void cargaMenu(){
        setBackground("Menu1.jpg");
        addObject(jugar,150,220);
        addObject(ayuda,300,220);
        addObject(creditos,450,220);
        addObject(menuEtiqueta[0],190,160);
        addObject(menuEtiqueta[1],340,160);
        addObject(menuEtiqueta[2],470,160);
        removeObject(atras);
    }
    /**
     * Encargado de agregar los objetos del juego al escenario, a fin de cargar la vista de el juego
     */
    public void cargaEscenario(){
        setBackground("Carretera1.jpg");
        addObject(bache[0],Greenfoot.getRandomNumber(270)+100,-100);
        addObject(bache[1],Greenfoot.getRandomNumber(270)+100,180);
        addObject(jugador,215,330);
        addObject(senal,33,30);//le falta '~' ariba de la 'n' ... jajajaja
        addObject(energia,550,100);
        addObject(vidasEtiqueta,500,280);
        addObject(metrosEtiqueta,500,330);
        Greenfoot.playSound("Arranque1.wav");
        motor.playLoop();
    }
    /**
     * Encargado de gestionar los cambios del jugador
     */
    public void actualizaDatos(){
        metrosEtiqueta.reescribe("Metros: "+jugador.getMetros()/5);
        vidasEtiqueta.reescribe("Vidas: "+jugador.getVidas());
        if(memEnergia != jugador.getEnergia()){
            memEnergia = jugador.getEnergia();
            energia.setImage("Vida"+memEnergia+".png");
        }
        if((jugador.getMetros()) % 2500==0){
            for(int step=0;step<3;step++)
                trafico[step].setVelocidad(trafico[step].getVelocidad()+1);
            bache[0].setVelocidad(bache[0].getVelocidad()+1);
            bache[1].setVelocidad(bache[1].getVelocidad()+1);
            Greenfoot.playSound("Carro1.WAV");
            limite++;
            if(limite<4)
                senal.setImage(limite+"0km.png");//le sigue faltando '~' a la 'n' (perdon: teclado gringo)
        }
        if((jugador.getMetros()/5)>=2500)
            juegoGanado();
        if((jugador.getMetros()/5)>=500)
            addObject(trafico[0],Greenfoot.getRandomNumber(90)+100,0);
        if((jugador.getMetros()/5)>=1000)
            addObject(trafico[1],Greenfoot.getRandomNumber(90)+190,0);
        if((jugador.getMetros()/5)>=2000)
            addObject(trafico[2],Greenfoot.getRandomNumber(90)+280,0);
    }
    /**
     * Encargado de checar el estado de los distintos botones y llamar a los metodos asociados a cada boton
     */
    public void checaBotones(){
        if(jugar.getPresionado()){
           jugar.setPresionado(false);
           remueveMenu();
           addObject(atras,35,365);
           cargaEscenario();
           jugando=true;
        }
        else if(ayuda.getPresionado()){
            ayuda.setPresionado(false);
            remueveMenu();
            setBackground("menuAyuda1.png");
            addObject(atras,35,365);
        }
        else if(creditos.getPresionado()){
            creditos.setPresionado(false);
            remueveMenu();
            setBackground("Creditos1.png");
            addObject(atras,35,365);
        }
        if(atras.getPresionado()){
            atras.setPresionado(false);
            remueveEscenario();
            cargaMenu();
            jugando=false;
        }
    }
    /**
     * Encargado de retirar el menu del escenario
     */
    public void remueveMenu(){
        removeObject(jugar);
        removeObject(ayuda);
        removeObject(creditos);
        for(int step=0;step<3;step++)
            removeObject(menuEtiqueta[step]);
    }
    /**
     * Encargado de retirar el contenido del juego
     */
    public void remueveEscenario(){
        removeObject(bache[0]);
        removeObject(bache[1]);
        for(int step=0;step<3;step++)
            removeObject(trafico[step]);
        removeObject(jugador);
        removeObject(energia);     
        removeObject(vidasEtiqueta);
        removeObject(metrosEtiqueta);
        removeObject(atras);
        removeObject(senal);
        motor.stop();
    }
    /**
     * Encargado de mostrar en pantalla que se ha perdido el juego
     */
    public void juegoPerdido(){
        remueveEscenario();
        setBackground("Perdido1.png");
        Greenfoot.delay(400);
        jugando=false;//por haber perdido
        cargaMenu();
    }
    /**
     * Encargado de mostrar en pantalla que se ha ganado el juego
     */
    public void juegoGanado(){
        remueveEscenario();
        setBackground("Ganaste.png");
        Greenfoot.delay(600);
        jugando=false;//por haber perdido
        cargaMenu();
    }
    /**
     * Encargado de restablecer los atributos necesario para comenzar a jugar nuevamente
     */
    public void restauraNivel(){
        jugador.restaurar();
        for(int step=0;step<3;step++)
            trafico[step].setVelocidad(2);
        bache[0].setVelocidad(1);
        bache[1].setVelocidad(1);
        limite=0;
        senal.setImage("00km.png");
    }
}
