import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
/**
 * Clase utilitaria, la cual maneja y asocia, objetos con movimiento e imagen
 */

public class Imagen  extends Actor{
    private int velocidad = 0;
    /**
     * Constructor propio de una imagen sin movimiento
     * @param nombre Nombre de la imagen asociada a su archivo
     */
    public Imagen(String nombre){
        this.velocidad = 0;
        setImage(nombre);
    }
    /**
     * Constructor propio de una imagen con movimiento
     * @param nombre Nombre de la imagen asociada a su archivo
     * @param velocidad Velocidad asignada al movimiento del objeto
     */
    public Imagen(String nombre, int velocidad){
        this.velocidad = velocidad;
        setImage(nombre);
    }
    /**
     * Modifica el atributo velocidad
     * @param velocidad Sobreescribe el atributo velocidad
     */
    public void setVelocidad(int velocidad){
        this.velocidad = velocidad;
    }
    /**
     * retorna el atributo velocidad
     * @return Atributo velocidad
     */
    public int getVelocidad(){
        return this.velocidad;
    }
    /**
     * Mueve al objeto y lo ubica nuevamente aleatoriamente si sale de pantalla
     */
    public void mover() {
        setLocation(getX(), getY()+velocidad);
        if(getY()>=399)//si se llega al final de pantalla
            setLocation(Greenfoot.getRandomNumber(260)+100,0);
    }
    /**
     * Encargado de determinar si un objeto este objeto choca o intersecta con otro
     */
    public boolean choque(Class clase){
        Actor chocado = getOneIntersectingObject(clase);
        return chocado != null;
    }
}