import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
/**
 * Clase principal en el juego, para control del estado del jugador
 */
public class Jugador  extends Carro
{
    private int distancia = 0, energia = 8, vida = 3, nitroImg=0, contadorTurbulencia = 0;
    private boolean chocado = false, muerto = false, turbo = false;//estado del turbo
    
    public Jugador() {
        super("car01-n.png",0);
    }
    /**
     * Sobreescribe el atributo "distancia"
     * @param distancia Sobreescribe la informacion en "distancia"
     */
    public void setMetros(int distancia){
        this.distancia=distancia;
    }
    /**
     * Sobreescribe el atributo "vida"
     * @param vida Sobreescribe la informacion en "vida"
     */
    public void setVidas(int vida){
        this.vida=vida;
    }
    /**
     * Sobreescribe el atributo "energia"
     * @param distancia Sobreescribe la informacion en "energia"
     */
    public void setEnergia(int energia){
        this.energia=energia;
    }
    /**
     * Retorna la distnacia que se ha recorrido por el jugador
     * @return distancia Metros avanzados
     */
    public int getMetros(){
        return distancia;
    }
    /**
     * Retorna el numero de vidas que tiene el jugador
     * @return vida Numero de vidas que posee el jugador
     */
    public int getVidas(){
        return vida;
    }
    /**
     * Retorna la energia que tiene el jugador
     * @return energia Cantidad de energia que posee el jugador
     */
    public int getEnergia(){
        return energia;
    }
    /**
     * Retorna el estado del jugador(vivo o muerto)
     * @return muerto Estado del jugador
     */
    public boolean getMuerto(){
        return muerto;
    }
    public void act() {
        if(Greenfoot.isKeyDown("up"   ))
           mover("arriba");
        else if(Greenfoot.isKeyDown("down" ))
           mover("abajo");        
        else if(Greenfoot.isKeyDown("left" ))
           mover("izquierda");
        else if(Greenfoot.isKeyDown("right"))
           mover("derecha");
        if(Greenfoot.isKeyDown("enter")&(distancia/5)>1000)
           turbo=true;
        if(Greenfoot.isKeyDown("space") | turbo==false){
           turbo=false;
           setImage("car01-n.png");
        }
        if(choque(Bache.class) & chocado==false | choque(Trafico.class) & chocado==false)
            chocado = true;
        if(turbo==true)
            turboImg();
        turbulencia();
        distancia++;       
        setCorxJugador(getX());//actualiza variable estatico (corX)(Carro.class)
    }
    /**
     * Encargado de redireccionar hacia una nueva posicion
     * @param direccion Direccion hacia la que se va a mover el jugador
     */
    public void mover(String direccion) {
        int gas;
        if(turbo)
            gas = 6;
        else
            gas = 2;
        if(direccion == "arriba"){
            setLocation(getX(), getY() - gas);
            distancia++;
        }
        else if(direccion == "abajo"){
            setLocation(getX(), getY() + gas);
            distancia--;
        }
        else if(direccion == "izquierda" & getX() > 90)
            setLocation(getX() - gas, getY());
        else if(direccion == "derecha" & getX() < 370)
            setLocation(getX() + gas, getY());
    }
    /**
     * Encargado del efecto asociado al derrape de jugador
     */
    public void turbulencia(){
        if(chocado==true){
            if(contadorTurbulencia==5)
                if (energia >= 1)
                    energia--;
            contadorTurbulencia+=1;
            if(contadorTurbulencia<=20)
               setRotation(getRotation()-1);
            else
               setRotation(getRotation()+1);
            if(contadorTurbulencia==2){
                if(choque(Bache.class))
                    Greenfoot.playSound("Derrape.wav");
               Greenfoot.playSound("choqueTrafico.wav");
            }
        }
        if(contadorTurbulencia >= 60){
            contadorTurbulencia = 0;
            chocado=false;
            setRotation(0);
            if(energia == 0){
                if (vida >= 2)
                   energia = 8;
                vida --;
            }
            if(vida == 0)
                muerto = true;
        }
    }
    /**
     * Encargado del efecto de turbo de jugador
     */
    public void turboImg(){
        if(nitroImg<5){
            nitroImg++;
            setImage("car06-n.gif");
        }
        else if(nitroImg<10){
            nitroImg++;
            setImage("car07-n.gif");
        }
        else{
            nitroImg++;
            setImage("car09-n.gif");
            if(nitroImg==15)
               nitroImg=0;
        }
    }
    /**
     * Reestablece los atributos del jugador a su estado inicial
     */
    public void restaurar(){
         contadorTurbulencia = 0;
         distancia = 0;
         energia = 8;
         vida = 3;
         turbo = false;//estado del turbo
         chocado = false;
         muerto = false;
    }
}